#include <stdio.h>
#include <gigatron/sys.h>
#include <gigatron/console.h>
#include <gigatron/libc.h>


struct Note
{
    int ch,noteoffset,volume,waveform,relative_pitch,start_step;	
};

struct Note notes[] = 
{//channel, pitch, volume, waveform,relative_pitch, start_step
{1, 62, 64, 2, 10, 0},
{1, 62, 64, 2, 20, 10},
{1, 62, 64, 2, 30, 20},
{1, 62, 64, 2, 20, 30},
{1, 62, 64, 2, 10, 40},
{1, 0, 0, 2, 0, 45},
{1, 62, 64, 2, -10, 50},
{1, 62, 64, 2, -20, 60},
{1, 62, 64, 2, -30, 70},
{1, 62, 64, 2, -20, 80},
{1, 62, 64, 2, -10, 90},
{1, 0, 0, 2, 0, 100},
};

struct Note *play_note(struct Note *note, int stepCount){
        while (stepCount == note->start_step) {
          channel_t *chan = &channel(note->ch);
          int off = note->noteoffset * 2;
		  int keyL = SYS_Lup(notesTable + off - 2);
		  int keyH = SYS_Lup(notesTable + off - 1);
		  int key_sum,keyL_new,keyH_new,key_sum_new;
		  
          chan->wavA = 128 - note->volume;
          chan->wavX = note->waveform;
		  
		  if(note->relative_pitch==0){
          chan->keyL = SYS_Lup(notesTable + off - 2);
          chan->keyH = SYS_Lup(notesTable + off - 1);			  			  
		  }else{
			  if(keyL>=100)key_sum=keyH*1000+keyL;
			  else key_sum=keyH*100+keyL;
			key_sum_new=key_sum+note->relative_pitch;
	
			keyL_new=key_sum_new%100;
			keyH_new=key_sum_new/100;
			
			chan->keyL = keyL_new;
		    chan->keyH = keyH_new;		

		  }
//		printf("keyH=%i,keyL=%i\n",chan->keyH,chan->keyL);		 		  
        note += 1;
        }
        return note;
}

void init_channel(){
	channel1.keyL=0;
	channel2.keyL=0;
	channel3.keyL=0;
	channel4.keyL=0;
	
	channel1.keyH=0;
	channel2.keyH=0;
	channel3.keyH=0;
	channel4.keyH=0;	
	
}

int main()
{
  register struct Note *note = notes;
  register int tmpfc = frameCount;
  register int stepCount = 0;
  init_channel();
  printf("Gigatron music engine\n");
  while(note->ch){ // using ch==0 to mark the end
    while (frameCount == tmpfc){ /* wait */ }     
    tmpfc = frameCount;
    note = play_note(note, stepCount);
    soundTimer = 1;
    stepCount += 1;
  }
  return 0;
}
